.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include drawtext_bitblt.inc

GetBmpBrushArray PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
	cx_     dd 16 ; character width should be set manually !
	abc_txt db 128 dup (0)
	;supports this ABC " !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~" 95-characters
.data?
	cy_     dd ?
	abc_br  dd 95 dup (?)

.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax

    invoke InitCommonControls
	invoke DialogBoxParam, hInstance, 1000, 0, addr DlgProc, 0
	invoke ExitProcess, 0


DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL ps  :PAINTSTRUCT
	LOCAL bm  :BITMAP
	LOCAL bmp :DWORD
	LOCAL x   :DWORD
	LOCAL y   :DWORD
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke szCopy, CADD("Why do things happen",13,10,"as they do in dreams?!"), ADDR abc_txt
		invoke SendDlgItemMessage, hWin, 1001, WM_SETTEXT, 0, ADDR abc_txt
		invoke LoadBitmap, hInstance, 13000
		mov    bmp, eax
		invoke GetBmpBrushArray, hWin, bmp, cx_, ADDR abc_br
		mov    cy_, eax
		invoke DeleteObject, bmp
		
	.elseif eax==WM_COMMAND
		.if wParam==1002
			invoke SendDlgItemMessage, hWin, 1001, WM_GETTEXT, 128, ADDR abc_txt
			invoke InvalidateRect, hWin, 0, 1
		.endif
		
	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		
		mov    esi, OFFSET abc_txt
		mov    x,   0
		mov    y,   0
		@@:
		; read one char, check if it's not zero
		xor    ecx, ecx
		mov    cl, [esi]
		test   cl, cl
		jz     @exit
		
		; test for new line
		cmp    cl, 13
		jnz    @no_newline
		mov    eax, cy_
		add    y, eax
		mov    x, 0
		jmp    @skip
		@no_newline:
		
		; get index of the glyph
		sub    cl, 32
		cmp    cl, 0
		jl     @skip
		cmp    cl, 95
		ja     @skip
		
		; get brush handle
		mov    ecx, [abc_br + ecx*4]
		
		invoke SelectObject,  ps.hdc, ecx
		invoke SetBrushOrgEx, ps.hdc, x, y, 0
		invoke PatBlt, ps.hdc, x, y, cx_, cy_, PATCOPY
		mov    eax, cx_
		add    x, eax
		@skip:
		inc    esi
		jmp    @B
		
		@exit:
		
		invoke EndPaint, hWin, ADDR ps
		
	.elseif eax==WM_CLOSE
		mov   esi, 0
		
		@@:
		invoke DeleteObject, DWORD PTR [abc_br + esi]
		
		add    esi, 4
		cmp    esi, 4*95
		jnz    @B
		
		invoke EndDialog, hWin, 0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

GetBmpBrushArray proc uses esi hWin:DWORD, hBmp:DWORD, im_x:DWORD, pBrushes:DWORD
	LOCAL bmp  :BITMAP
	LOCAL dc   :DWORD
	LOCAL bmpX :DWORD
	LOCAL mdcY :DWORD
	LOCAL mdcX :DWORD
	LOCAL bOld :DWORD
	LOCAL bOldX:DWORD
	
	invoke GetDC, hWin
	mov    dc,   eax
		
	invoke GetObject, hBmp, sizeof BITMAP, ADDR bmp
		
	mov    eax, bmp.bmWidth
	xor    edx, edx
	div    im_x
	mov    esi, eax
		
	invoke CreateCompatibleDC, dc
	mov    mdcY, eax
	invoke CreateCompatibleDC, dc
	mov    mdcX, eax
	invoke SelectObject, mdcX, hBmp
	mov    bOldX, eax
		
	test   esi,  esi
	jz     @exit
	;-----
	@@:
	dec    esi
		
	invoke CreateCompatibleBitmap, dc, im_x, bmp.bmHeight
	mov    bmpX, eax
	invoke SelectObject, mdcY, bmpX
	mov    bOld, eax
	mov    eax,  esi
	mul    im_x
	invoke BitBlt, mdcY, 0, 0, im_x, bmp.bmHeight, mdcX, eax, 0, SRCCOPY
	invoke GetCurrentObject, mdcY, OBJ_BITMAP
	mov    edi, eax
	invoke CreatePatternBrush, edi
	mov    ecx,   esi
	shl    ecx,   2
	add    ecx,   pBrushes
	mov    [ecx], eax
	invoke SelectObject, mdcY, bOld
	invoke DeleteObject, edi
	
	test   esi,   esi
	jnz    @B
	@exit:
	;-----
	invoke SelectObject, mdcX, bOldX
	invoke DeleteDC,     mdcX
	invoke DeleteDC,     mdcY
	invoke ReleaseDC,    hWin, dc
	
	mov    eax, bmp.bmHeight
	ret

GetBmpBrushArray endp

end start
